/**
* @@@BUILDINFO@@@ ResizeImages.jsx !Version1.4! Mon Dec 21 2009 17:19:13 GMT+0200
*/
#target indesign
CheckInDesign();
CheckPhotoshop();
var myRepResampled = myRepNotResampled = myRep100Percent = myRepNotProp = myRepLocked = myPsError = "";
var myOldTransPreferences;
//~ var myTotalLinksCount;
var myDialogResult = CreateDialog();
if (myDialogResult == undefined) {
	exit();
}
var myDoc = app.activeDocument;

if (app.version.substr(0, 5) == "6.0.4") {
	var myRememberPreserveBounds = app.imagePreferences.preserveBounds;
	app.imagePreferences.preserveBounds = false;
}

var myAllLinks = GetAllLinks();
myDoc.links.everyItem().insertLabel("Status", "");
if (myDialogResult.checkMissing) CheckLinks();
if (myDialogResult.checkResolution) CheckEffectivePpi();
var myCompletedLinks = [];
UpdateAllOutdatedLinks();
SetTransformPrefs();
SetDisplayDialogs("NO");
CollectImages(myAllLinks);
//------------------------------------------------ End of the script -------------------------------------------------
app.transformPreferences.properties = myOldTransPreferences;
if (myRememberPreserveBounds != undefined) app.imagePreferences.preserveBounds = myRememberPreserveBounds;
SetDisplayDialogs("ALL");

if (myCompletedLinks.length > 0) {
	if (myDialogResult.report) CreateReport();
	UpdateAllOutdatedLinks();
	alert(localize({en: 'All done.', ru: 'Всё готово.'}), localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}));
}
else {
	alert(localize({en: 'Nothing has been resized.', ru: 'Ничего не было пересчитано.'}), localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}));
}
//*************************************************** FUNCTIONS  *************************************
function CreateDialog() {
	var myArray = [];
	
	if (File.fs == "Macintosh" && $.locale == "en") {
		var myListBoxBounds = [0, 0, 564, 160];
	}
	else if (File.fs == "Macintosh" && $.locale == "ru")  {
		var myListBoxBounds = [0, 0, 640, 160];
	}
	else if (File.fs == "Windows" && $.locale == "en")  {
		var myListBoxBounds = [0, 0, 508, 160];
	}
	else if (File.fs == "Windows" && $.locale == "ru") {
		var myListBoxBounds = [0, 0, 580, 160];
	}
	else {
		var myListBoxBounds = [0, 0, 564, 160];
	}

	if (app.extractLabel("KasIgnoredFolders") != "") {
		myArray = app.extractLabel("KasIgnoredFolders").split(",");
	}
	var dlg = new Window('dialog', localize({en: 'Resize Images', ru: 'Пересчёт картинок'}));
	// ------------------- containers ---------------------------
	dlg.orientation = 'column';
	dlg.alignChildren = 'top';
	dlg.btnPnl = dlg.add('panel', undefined, localize({en: 'Ignored folders', ru: 'Запрещённые папки'}));
	dlg.btnPnl.orientation = 'column';
	dlg.btnPnl.helpTip = localize({en: 'The files in these folders will not be resized', ru: 'Файлы в этих папках не будут пересчитаны'});
	// ---------------------- listbox --------------------------
	dlg.btnPnl.listBox = dlg.btnPnl.add('listbox', undefined, myArray, {multiselect:true});
	dlg.btnPnl.listBox.bounds = myListBoxBounds;	
	// ---------------------- buttons ----------------------------
	dlg.btnPnl.grp = dlg.btnPnl.add('group');
	dlg.btnPnl.grp.orientation = 'row';
	dlg.btnPnl.grp.addBtn = dlg.btnPnl.grp.add('button', undefined, localize({en: 'Add', ru: 'Добавить'}));
	dlg.btnPnl.grp.addBtn.helpTip = localize({en: 'Add a  folder to the list', ru: 'Добавить папку в список'});
	dlg.btnPnl.grp.removeBtn = dlg.btnPnl.grp.add('button', undefined, localize({en: 'Remove', ru: 'Убрать'}));
	dlg.btnPnl.grp.removeBtn.helpTip = localize({en: 'Remove the selected  folders from the list', ru: 'Убрать выделенные папки из списка'});
	dlg.btnPnl.grp.remAllBtn = dlg.btnPnl.grp.add('button', undefined, localize({en: 'Remove All', ru: 'Убрать все'}));
	dlg.btnPnl.grp.remAllBtn.helpTip = localize({en: 'Remove all  folders from the list', ru: 'Убрать все папки из списка'});
	// ---------------------- group--------------------------	
	dlg.grp = dlg.add('group');
	dlg.grp.orientation = 'row';
	dlg.grp.alignChildren = 'top';
	// ---------------------- checkboxes --------------------------
	dlg.grp.checkBoxPnl = dlg.grp.add('panel', undefined, localize({en: 'Options', ru: 'Настройки'}));
	dlg.grp.checkBoxPnl.alignChildren = 'left';
	dlg.grp.checkBoxPnl.masterPagesCb = dlg.grp.checkBoxPnl.add('checkbox', undefined, localize({en: 'Resize images on master pages', ru: 'Пересчитывать на мастер-страницах'}));
	dlg.grp.checkBoxPnl.ancoredCb = dlg.grp.checkBoxPnl.add('checkbox', undefined, localize({en: 'Resize anchored images', ru: 'Пересчитывать привязанные объекты'}));
	dlg.grp.checkBoxPnl.pasteboardCb = dlg.grp.checkBoxPnl.add('checkbox', undefined, localize({en: 'Resize images on pasteboard', ru: 'Пересчитывать на рабочем столе'}));
	dlg.grp.checkBoxPnl.checkMissingCb = dlg.grp.checkBoxPnl.add('checkbox', undefined, localize({en: 'Check for missing links', ru: 'Проверять потерянные ссылки'}));
	dlg.grp.checkBoxPnl.reportCb = dlg.grp.checkBoxPnl.add('checkbox', undefined, localize({en: 'Create report on the desktop', ru: 'Создать отчёт  на рабочем столе'}));
	dlg.grp.checkBoxPnl.reportCb.helpTip = localize({en: 'If checked, a text file containing report about еру script operation will be created on the desktop', ru: 'Создать файл отчёта о результатах работы скрипта на рабочем столе'});
	dlg.grp.checkBoxPnl.subGrp = dlg.grp.checkBoxPnl.add('group');
	dlg.grp.checkBoxPnl.subGrp.orientation = 'row';
	dlg.grp.checkBoxPnl.subGrp.checkResCb = dlg.grp.checkBoxPnl.subGrp.add('checkbox', undefined, localize({en: 'Warn if effective resolution is less then', ru: 'Предупреждать если разрешение меньше '}));
	dlg.grp.checkBoxPnl.subGrp.checkResCb.helpTip = localize({en: 'If resolution of some image is below the limit, the script will warn you about that. ', ru: 'Если разрешение какой-либо картинки ниже заданного уровня, то скрипт предупредит об этом.'});
	if (app.extractLabel("KasMinimumDpi") != "") {
		var myDpi = app.extractLabel("KasMinimumDpi");
	}
	else {
		var myDpi = "300";
	}
	dlg.grp.checkBoxPnl.subGrp.et = dlg.grp.checkBoxPnl.subGrp.add('edittext', undefined, myDpi);
	dlg.grp.checkBoxPnl.subGrp.st = dlg.grp.checkBoxPnl.subGrp.add('statictext', undefined, 'dpi');
	dlg.grp.checkBoxPnl.selImgCb = dlg.grp.checkBoxPnl.add('checkbox', undefined, localize({en: 'Resize only selected images', ru: 'Пересчитывать только выделенные картинки'}));
	
	if (app.extractLabel("KasCheckBoxes") != "") {
		var myCbValues = app.extractLabel("KasCheckBoxes").split(",");
		dlg.grp.checkBoxPnl.masterPagesCb.value = eval(myCbValues[0]);
		dlg.grp.checkBoxPnl.ancoredCb.value = eval(myCbValues[1]);
		dlg.grp.checkBoxPnl.pasteboardCb.value = eval(myCbValues[2]);
		dlg.grp.checkBoxPnl.checkMissingCb.value = eval(myCbValues[3]);
		dlg.grp.checkBoxPnl.reportCb.value = eval(myCbValues[4]);
		dlg.grp.checkBoxPnl.subGrp.checkResCb.value = eval(myCbValues[5]);
		dlg.grp.checkBoxPnl.selImgCb.value = eval(myCbValues[6]);
	}
	else {
		dlg.grp.checkBoxPnl.masterPagesCb.value = true;
		dlg.grp.checkBoxPnl.ancoredCb.value = true;
		dlg.grp.checkBoxPnl.pasteboardCb.value = false;
		dlg.grp.checkBoxPnl.checkMissingCb.value = true;
		dlg.grp.checkBoxPnl.reportCb.value = true;
		dlg.grp.checkBoxPnl.subGrp.checkResCb.value = true;	
		dlg.grp.checkBoxPnl.selImgCb.value = false;
	}	

	if (app.selection.length == 1 && app.selection[0].constructor.name == "Image") {
		dlg.grp.checkBoxPnl.selImgCb.enabled = true;
	}
	else if (app.selection.length >= 1) {
		var aaa = app.selection[0];
		try {
			if (app.selection[0].allGraphics.length > 0) dlg.grp.checkBoxPnl.selImgCb.enabled = true;
			}
		catch(e) {
			$.writeln("Error: " + e.message);
			dlg.grp.checkBoxPnl.selImgCb.enabled = false;
		}
	}
	else {
		dlg.grp.checkBoxPnl.selImgCb.enabled = false;
	}

	dlg.grp.checkBoxPnl.selImgCb.addEventListener('click', SelImgCbClick);
	
	if (dlg.grp.checkBoxPnl.selImgCb.value && dlg.grp.checkBoxPnl.selImgCb.enabled) {
		dlg.grp.checkBoxPnl.masterPagesCb.enabled =  false;
		dlg.grp.checkBoxPnl.ancoredCb.enabled =  false;
		dlg.grp.checkBoxPnl.pasteboardCb.enabled =  false;
	}
	// ---------------------- subgroup  --------------------------	
	dlg.grp.subGrp = dlg.grp.add('group');
	dlg.grp.subGrp.orientation = 'column';
	dlg.grp.subGrp.radioPanel = dlg.grp.subGrp.add('panel', undefined, localize({en: 'Enlarged images', ru: 'Увеличенные картинки'}));
	dlg.grp.subGrp.radioPanel.alignment = 'left';
	dlg.grp.subGrp.radioPanel.alignChildren = 'left';
	// ---------------------- radiobuttons --------------------
	dlg.grp.subGrp.radioPanel.rad1 = dlg.grp.subGrp.radioPanel.add('radiobutton', undefined, localize({en: 'Resize without resampling', ru: 'Пересчитывать без ресамплинга'}));
	dlg.grp.subGrp.radioPanel.rad2 = dlg.grp.subGrp.radioPanel.add('radiobutton', undefined, localize({en: 'Resize with resampling', ru: 'Пересчитывать с ресамплингом'}));
	dlg.grp.subGrp.radioPanel.rad3 = dlg.grp.subGrp.radioPanel.add('radiobutton', undefined, localize({en: 'Don\'t resize', ru: 'Не пересчитывать'}));
	
	if (app.extractLabel("KasRadioSelected") != "") {
		eval("dlg.grp.subGrp.radioPanel.rad" + app.extractLabel("KasRadioSelected") + ".value= true");
	}
	else {
		dlg.grp.subGrp.radioPanel.rad1.value = true;
	}
	
	dlg.grp.subGrp.testPanel = dlg.grp.subGrp.add('panel', undefined, '');
	dlg.grp.subGrp.testPanel.alignment = 'left';
	dlg.grp.subGrp.testPanel.orientation = 'column';
	dlg.grp.subGrp.testPanel.alignChildren = 'left';	
		
	dlg.grp.subGrp.okBtn = dlg.grp.subGrp.add('button', undefined, localize({en: 'Resize', ru: 'Пересчитать'}), {name:'ok'});
	dlg.grp.subGrp.cancelBtn = dlg.grp.subGrp.add('button', undefined, localize({en: 'Cancel', ru: 'Отменить'}), {name:'cancel'});

	// ----------------------- functions --------------------------
	function SelImgCbClick() {
		if (this.value) {
			dlg.grp.checkBoxPnl.masterPagesCb.enabled =  false;
			dlg.grp.checkBoxPnl.ancoredCb.enabled =  false;
			dlg.grp.checkBoxPnl.pasteboardCb.enabled =  false;
		}
		else {
			dlg.grp.checkBoxPnl.masterPagesCb.enabled =  true;
			dlg.grp.checkBoxPnl.ancoredCb.enabled =  true;
			dlg.grp.checkBoxPnl.pasteboardCb.enabled =  true;
		}
	}
	dlg.btnPnl.grp.addBtn.onClick = function() {
		var myFolder = Folder.selectDialog ("Select a folder");
		if (myFolder != null) {
			if (!IsInArray(myFolder.fsName, myArray)) {
				myArray.push(myFolder.fsName);
				var myBounds = dlg.btnPnl.listBox.bounds;
				dlg.btnPnl.remove(dlg.btnPnl.listBox);
				dlg.btnPnl.listBox = dlg.btnPnl.add('listbox', myBounds, myArray, {multiselect:true});
				dlg.btnPnl.listBox.bounds = myListBoxBounds;
			}
			else {
				alert("This folder has been already added.");
			}
		}
	}
	dlg.btnPnl.grp.removeBtn.onClick = function() {
		if (dlg.btnPnl.listBox.selection != null) {
			for (var i = dlg.btnPnl.listBox.selection.length - 1; i  >= 0; i --) {
				myArray.splice(dlg.btnPnl.listBox.selection[i].index, 1);
				dlg.btnPnl.listBox.remove(dlg.btnPnl.listBox.selection[i]);

			}
		}
	}
	dlg.btnPnl.grp.remAllBtn.onClick = function() {
		dlg.btnPnl.listBox.removeAll();
		myArray = [];
	}
	dlg.grp.subGrp.okBtn.onClick = function() {
		myArray.splice(0, myArray.length);
		for (j = 0; j < dlg.btnPnl.listBox.items.length; j++) {
			myArray.push(dlg.btnPnl.listBox.items[j].text);
		}
		dlg.close();
	}
	dlg.grp.subGrp.cancelBtn.onClick = function() {
		dlg.close(1);
	}
dlg.grp.checkBoxPnl.subGrp.et.onChange = function() {
	if (parseInt(this.text ).toString() == "NaN") {
		alert (this.text + localize({en: ' is not number!', ru: ' не цифра'}));
	}
}
// ---------------------------------------------------------------
	var myDialogResult = dlg.show();
	if (!myDialogResult) {
		var myRadSelected;
		if (dlg.grp.subGrp.radioPanel.rad1.value) {
			myRadSelected = 1;
		}
		else if(dlg.grp.subGrp.radioPanel.rad2.value) {
			myRadSelected = 2;
		}
		else if(dlg.grp.subGrp.radioPanel.rad3.value) {
			myRadSelected = 3;
		}
	
		myDpi = parseInt(dlg.grp.checkBoxPnl.subGrp.et.text);
		if (myDpi.toString() == "NaN") {
			myDpi = 300;
		}
								
		app.insertLabel("KasIgnoredFolders", myArray.join(","));
		app.insertLabel("KasRadioSelected", myRadSelected + "");
		app.insertLabel("KasMinimumDpi", myDpi.toString());
		app.insertLabel("KasCheckBoxes", [	dlg.grp.checkBoxPnl.masterPagesCb.value,
														dlg.grp.checkBoxPnl.ancoredCb.value,
														dlg.grp.checkBoxPnl.pasteboardCb.value,
														dlg.grp.checkBoxPnl.checkMissingCb.value,
														dlg.grp.checkBoxPnl.reportCb.value,
														dlg.grp.checkBoxPnl.subGrp.checkResCb.value,
														dlg.grp.checkBoxPnl.selImgCb.value  ].join(","));
		var myResult = {};
		myResult.folders = myArray;
		myResult.radio = myRadSelected;
		myResult.masterPages = dlg.grp.checkBoxPnl.masterPagesCb.value;
		myResult.anchored = dlg.grp.checkBoxPnl.ancoredCb.value;
		myResult.pasteboard = dlg.grp.checkBoxPnl.pasteboardCb.value;
		myResult.checkMissing = dlg.grp.checkBoxPnl.checkMissingCb.value;
		myResult.checkResolution = dlg.grp.checkBoxPnl.subGrp.checkResCb.value;
		myResult.onlySelected = dlg.grp.checkBoxPnl.selImgCb.value;
		myResult.onlySelEnabled = dlg.grp.checkBoxPnl.selImgCb.enabled;
		myResult.minimumDpi = parseInt(dlg.grp.checkBoxPnl.subGrp.et.text);
		myResult.report = dlg.grp.checkBoxPnl.reportCb.value;
		return myResult;
	}
}
//--------------------------------------------------------------------------------------------------------------
function whereIsTheLink(theLink){
	while (theLink.constructor.name != 'Application') {
		if (theLink instanceof Page) {
			var myPageName = theLink.name;
			return myPageName;
		}
		if (theLink instanceof Character) {
			if (theLink.parentTextFrames[0] != undefined && theLink.parentTextFrames[0].constructor.name == "TextFrame") {
				var thePage = whereIsTheLink(theLink.parentTextFrames[0]);
			}
			else if (theLink.parentTextFrames[0] == undefined && theLink.parent.constructor.name == "Story") {
				var thePage = whereIsTheLink(theLink.parent.textContainers[theLink.parent.textContainers.length-1]);
			}
		}
	theLink = theLink.parent;
	myHierarchy += theLink.constructor.name + '|';
	}
	
	if (myHierarchy.lastIndexOf('|Page|MasterSpread|Document|Application|') != -1) {
		return 'master page';
	}
	else if (myHierarchy.lastIndexOf('|MasterSpread|Document|Application|') != -1) {
		return 'pasteboard of master page';
	}
	else if (myHierarchy.lastIndexOf('|Spread|Document|Application|') != -1) {
		return 'pasteboard';
	}
	else if (myHierarchy.lastIndexOf('Image|Rectangle|Character|Page|') != -1) {
		return 'anchored';
	}
	else {
		return 'unknown';
	}
}
//--------------------------------------------------------------------------------------------------------------
function findLargestLink(myLink) {
	var myMultyLinks = [];
	for (var myCounter =  0; myCounter < myAllLinks.length; myCounter++) {
		if (myLink.filePath == myAllLinks[myCounter].filePath) {
			myMultyLinks.push(myAllLinks[myCounter]);
		}
	}
	var myLargestLink = myMultyLinks[0];
	for (var k =  1; k < myMultyLinks.length; k++) {
		var theLink = myMultyLinks[k];
		var myImage = theLink.parent;
		var myHorScale = myImage.absoluteHorizontalScale;
		var myVerScale = myImage.absoluteVerticalScale;
		if (myHorScale > myLargestLink.parent.absoluteHorizontalScale) { // !!! Vertical
			myLargestLink = theLink;
		}
	}
	return myLargestLink;
}
//--------------------------------------------------------------------------------------------------------------
function ResizeImage(myLink) {
	var myImagePath = myLink.filePath;
	var myImage = myLink.parent;
	var myFrame = myLink.parent.parent;
	try {
		myFrame.redefineScaling();
	}
	catch(err) {}
	if (myFrame.locked || myFrame.itemLayer.locked)  {
		myRepLocked += myImagePath + localize({en: ' – image is locked \r', ru: ' – картинка заблокирована'});
		return;
	}
	var myHorScale = Math.abs(myImage.absoluteHorizontalScale);
	var myVerScale = Math.abs(myImage.absoluteVerticalScale);
	var myEffPpi = myImage.effectivePpi[0];
	
	if (Math.round(myHorScale) == Math.round(myVerScale)) { // Proportional
		if (Math.round(myHorScale) == 100 ) {
			myRep100Percent += myImagePath + "\r";
			return;
		}
		else if ((myHorScale < 100 && myEffPpi > 300)  || (myHorScale > 100 && myDialogResult.radio == 2)) {
			var myResampleMethod = "ResampleMethod.BICUBICSHARPER";
			ResizeInPS(myImagePath, myHorScale, myVerScale, undefined, myResampleMethod);
			setLink100percent(myLink);
			myRepResampled += myImagePath + " " + Math.round(myHorScale) + "%\r";
		}
		else if ((myHorScale > 100 && myDialogResult.radio == 1) || (myHorScale < 100 && myEffPpi <= 300 && myDialogResult.radio != 3)) {
			var myResampleMethod = "ResampleMethod.NONE";
			ResizeInPS(myImagePath, undefined, undefined, myEffPpi, myResampleMethod);
			setLink100percent(myLink);
			myRepNotResampled += myImagePath + " " + Math.round(myHorScale) + "%\r";
		}

	}
	else if ((Math.round(myHorScale) != Math.round(myVerScale)) && (LinkUsage(myLink) == 1)) { // Not proportional and used once
		var myResampleMethod = "ResampleMethod.BICUBICSHARPER";		
		ResizeInPS(myImagePath, myHorScale, myVerScale, undefined, myResampleMethod);
		setLink100percent(myLink);
		myRepNotProp+= myImagePath + " " + Math.round(myHorScale) + "% x " + Math.round(myVerScale) + "%\r";
	}
}
//--------------------------------------------------------------------------------------------------------------
function ResizeInPS(myPath, myHorScale, myVerScale, myResolution, myResampleMethod) {
	var bt = new BridgeTalk;
	bt.target = "photoshop";
	var myScript = 'try {\n';
	myScript += 'var myPsDoc = app.open(File(\"' + myPath + '\"));\n';
	myScript += 'app.preferences.rulerUnits = Units.PERCENT; \n' ;
	myScript += 'myPsDoc.resizeImage(' + myHorScale +', ' + myVerScale + ', ' + myResolution + ', ' + myResampleMethod + '); \n';
	myScript += 'myPsDoc.save();\n';
	myScript += 'myPsDoc.close();\n';
	myScript += '}\n';
	myScript += 'catch (myError) {\n';
	myScript += 'myPsError += \"myError -- ' + myPath + '\";\n';
	myScript += '}';
	bt.body = myScript;
	bt.onResult = function(resObj) {} // empty function - to wait untill PS finishes processing the file
	bt.send(100); // !!! bt.send(1);
}
//--------------------------------------------------------------------------------------------------------------
function setLink100percent(myLink) {
//$.write("setLink100percent\nmyLink.status" + myLink.status + "\n");
	try {
		var myLink = myLink.update();
	}
	catch(err) {
//~ 		$.write("myLink.update error: " + err);
	}
	var myImage = myLink.parent;
	if (myLink.parent.absoluteHorizontalScale > 0 && myLink.parent.absoluteVerticalScale > 0) {
		myImage.absoluteHorizontalScale = 100;
		myImage.absoluteVerticalScale = 100;
	}
	myLink.insertLabel("Status", "Ready");
	myCompletedLinks.push(myLink);
}
//--------------------------------------------------------------------------------------------------------------
function UpdateAllOutdatedLinks() {
	for(var myCounter = myDoc.links.length-1; myCounter >= 0; myCounter--){
		var myLink = myDoc.links[myCounter];
		//$.write("UpdateAllOutdatedLinks\nmyLink.status = " + myLink.status + "\nmyCounter = " + myCounter + "\n");
		if (myLink.status == LinkStatus.linkOutOfDate){
			myLink.update();
		}
	}
}
//--------------------------------------------------------------------------------------------------------------
function SetDisplayDialogs(Mode) {
	var bt = new BridgeTalk;
	bt.target = "photoshop";
	var myScript = 'app.displayDialogs = DialogModes.' + Mode + ';';
	bt.body = myScript;
	bt.send();
}
//--------------------------------------------------------------------------------------------------------------
function CreateReport() {
	var myDate = new Date();
	myReport = myDate.toLocaleString() + '\rFile: ' + myDoc.fullName.fullName + '\r\r';
	if (myRepResampled != '') {
		myReport += localize({en: 'The following images were resized with resampling:\r', ru: 'С уменьшением были пересчитаны следующие картинки:\r'}) + myRepResampled + '\r';
	}
	if (myRepNotResampled != '') {
		myReport +=  localize({en: 'The following images were resized without resampling:\r', ru: 'С увеличением были пересчитаны следующие картинки:\r'}) + myRepNotResampled + '\r';
	}
	if (myRep100Percent != '') {
		myReport +=  localize({en: 'The following images were not resized, as they had already been placed at 100%:\r', ru: 'На 100% уже стояли  картинки:\r'}) + myRep100Percent + '\r';
	}
	if (myRepNotProp != '') {
		myReport += localize({en: 'The following images were resized non-uniformly:\r', ru: 'Непропорционально были пересчитаны следующие картинки:\r'}) + myRepNotProp + '\r';
	}
	if (myRepLocked != '') {
		myReport +=  localize({en: 'The following images were not resized because they are locked:\r', ru: 'Не были пересчитаны следующие картинки, потому что они заблокированы:\r'}) + myRepLocked + '\r';
	}
	if (myPsError != '') {
		myReport +=  localize({en: 'The following images were not resized (probably because they are damaged):\r', ru: 'Не были пересчитаны следующие картинки, потому что они вероятно запорченные:\r'}) + myPsError + '\r';
	}
	myReport +=  '----------------------------------------------------\r';
	WriteToFile(myReport);
}
//--------------------------------------------------------------------------------------------------------------
function WriteToFile(myText) {
	myFile = new File("~/Desktop/Report.txt");
	if ( myFile.exists ) {
		myFile.open("e");
		myFile.seek(0, 2);
	}
	else {
		myFile.open("w");
	}
	if (File.fs == "Macintosh" && $.locale == "ru") {
		myFile.encoding = "X-MAC-CYRILLIC";
	}
	myFile.write(myText); 
	myFile.close();
}
//--------------------------------------------------------------------------------------------------------------
function IsInArray(myString, myArray) {
	for (x in myArray) {
		if (myString == myArray[x]) {
			return true;
		}
	}
	return false;
}
//--------------------------------------------------------------------------------------------------------------
function err(e, icon){
	alert(e, localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}), icon);
	exit();
}
//--------------------------------------------------------------------------------------------------------------
function CheckPhotoshop() {  
	var mySpecifier = BridgeTalk.getSpecifier("photoshop");
	if (mySpecifier == null) err(localize({en: 'The script can\'t run because Photoshop is not installed.', ru: 'Скрипт нельзя запустить, поскольку Фотошоп не установлен.'}));
	var myPS_version = mySpecifier.search(/\d+/);
	if (myPS_version < 10) err(localize({en: 'The script requires Photoshop at least version \"11\", but you have version \"', ru: 'Для работы скрипта необходим по крайней мере Фотошоп версии \"11\", а у вас установлена '}) + myPS_version + localize({en: '\" installed.', ru: ' версия.'}));
	if (!BridgeTalk.isRunning ("photoshop")) {
		var myConfirm = confirm(localize({en: 'Photoshop is not running. Do you want to launch it?', ru: 'Фотошоп не запущен. Хотите его запустить?'}), false, localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}));
		if (myConfirm) {
			BridgeTalk.launch("photoshop");
			err(localize({en: 'Wait untill Photoshop finishes loading and run the script again.', ru: 'Подождите пока загрузиться Фотошоп и запустите скрипт снова'}), false);
		}
		else {
			exit();
		}
	}
}
//--------------------------------------------------------------------------------------------------------------
function CheckInDesign() {
	if (app.documents.length == 0) {
		err(localize({en: 'No documents are open. Please open a document and try again.', ru: 'Не открыт ни один документ, откройте файл и попробуйте снова.'}));
	}
	if (!app.activeDocument.saved) {
		err(localize({en: 'The current document has not been saved since it was created. Please save the document and try again.', ru: 'Этот файл ещё ни разу не был сохранен. Сохраните его и попробуйте запустить скрипт снова.'}));
	}
	if (app.activeDocument.allGraphics.length == 0) {
		err(localize({en: 'The current document contains no images.', ru: 'В этом файле нет растровых картинок.'}));
	}
}
//--------------------------------------------------------------------------------------------------------------
function SetTransformPrefs() {
	myOldTransPreferences = app.transformPreferences.properties;
	app.transformPreferences.transformationsAreTotals = true;
	app.transformPreferences.showContentOffset = true;
	app.transformPreferences.dimensionsIncludeStrokeWeight = true;
	app.transformPreferences.whenScaling = WhenScalingOptions.APPLY_TO_CONTENT; // ADJUST_SCALING_PERCENTAGE;
}
//--------------------------------------------------------------------------------------------------------------
function CheckLink(myLink) {
	if (myLink.parent.constructor.name == "ImportedPage")  return false; // link is inside of indd-file
	if (myLink.linkType != "TIFF" && myLink.linkType != "Photoshop" && myLink.linkType != "JPEG" ) return false; // !!! photoshop EPS
	//$.writeln("CheckLink-Type=true " + myLink.filePath);
	if (myLink.parent.space == "Black and White") return false; // bitmap
	//if (myLink.extractLabel("Status") == "Ready") return false; // already completed
	if (myLink.status != LinkStatus.NORMAL) return false;
	if (IsInArray(new File(myLink.filePath).parent.fsName, myDialogResult.folders)) return false; // in ignored folders
	var myPlacement = whereIsTheLink(myLink);
	if (!myDialogResult.pasteboard && myPlacement == 'pasteboard')  return false;
	if (!myDialogResult.anchored && myPlacement == 'anchored')  return false;
	if (!myDialogResult.masterPages && myPlacement == 'master page')  return false;
	if ((!myDialogResult.masterPages && !myDialogResult.pasteboard) && myPlacement == 'pasteboard of master page')  return false;
	return true;
}
//--------------------------------------------------------------------------------------------------------------
function CollectImages() {
	var myLinks = [];
	var myMultiUsedLinks = [];
	for (var myCounter =  0; myCounter  < myAllLinks.length; myCounter++) {
		var myLink = myAllLinks[myCounter];
		if (CheckLink(myLink)) {
			var myLinkUsedTimes = LinkUsage(myLink);
			if (myLinkUsedTimes == 1) {
				myLinks.push(myLink);
			}
			else if (myLinkUsedTimes > 1) {
				var myLargestLink = findLargestLink(myLink); // !!!
				if (!IsObjInArray(myLargestLink, myMultiUsedLinks)) {
					myMultiUsedLinks.push(myLargestLink);
				}
			}
		}
	}
//~ 	myTotalLinksCount = myLinks.length + myMultiUsedLinks.length;
	
	if (myMultiUsedLinks.length > 0) {
		for (k = 0; k < myMultiUsedLinks.length; k++) {
			myLinks.push(myMultiUsedLinks[k]);
		}
	}	
	
	if (myLinks.length > 0) {
		ProcessImages(myLinks);
	}

	if (myLinks.length == 0 && myMultiUsedLinks.length == 0) {
		err(localize({en: 'No suitable images to resize.', ru: 'Нет подходящих картинок для пересчёта.'}));
	}
}
//--------------------------------------------------------------------------------------------------------------
function ProcessImages(myLinks) {
	var myStop = myLinks.length;
	var myPbValue = 1;
	var myWindow = new Window ( 'window', localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}) );
	var myProgressBar = myWindow.add ('progressbar', [12, 12, 350, 24], 0, myStop);
	var myStaticText = myWindow.add('statictext');
	myStaticText.bounds = [0, 0, 340, 20];
	myStaticText.alignment = "left";
	myWindow.show();
	for (var myCounter = myLinks.length - 1; myCounter  >= 0; myCounter --) {
		var myLink = myLinks[myCounter];
		
		myProgressBar.value = myPbValue;
		myStaticText.text = (localize({en: 'Resizing - ', ru: 'Пересчитываю - '}) + myLink.name);
		myWindow.text = localize({en: 'Image ', ru: 'Картинка '}) + myPbValue + localize({en: ' out of ', ru: ' из '}) + myLinks.length;
		myPbValue++;
		
		ResizeImage(myLink);
	}
	myWindow.close();
}
//--------------------------------------------------------------------------------------------------------------
function LinkUsage(myLink) {
	var myLinkCounter = 0;
		for (var myCounter =  0; myCounter < myAllLinks.length; myCounter++) {
		if (myLink.filePath == myAllLinks[myCounter].filePath) {
			myLinkCounter++;
		}
	}
	return myLinkCounter
}
//--------------------------------------------------------------------------------------------------------------
function CheckLinks() {
	var myMissingLinks = [];
	for(var n = 0; n < myDoc.links.length; n++) {
		var myLink = myDoc.links[n];
		if (myLink.status == LinkStatus.linkMissing) {
			myMissingLinks.push(myLink);
		}
	}
	if (myMissingLinks.length == 1) {
		myMissingLinks[0].show();
		var myConfirm = confirm(localize({en: 'This link is missing, do you want to stop the script and repair it?', ru: 'Внимание! Этот линк потерянный.  Хотите остановить скрипт и исправить?'}), false, localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}));
		if (myConfirm) {
			exit();
		}
	}
	else if (myMissingLinks.length > 1) {
		var myConfirm = confirm(localize({en: 'This document contains ', ru: 'Этот документ содержит '}) + myMissingLinks.length + localize({en: ' missing links. Do you want to stop the script and repair them?"', ru: ' потерянных  ссылок. Хотите остановить скрипт и исправить?'}), false, localize({en: 'Resize Images Script', ru: 'Пересчёт картинок'}));
		if (myConfirm) {
			exit();
		}
	}
}
//--------------------------------------------------------------------------------------------------------------
function CheckEffectivePpi() {
	var myLowResImages = [];
	for (o = 0; o < myAllLinks.length; o++) {
		var myLink = myAllLinks[o];
		if (myLink.parent.constructor.name == "Image") {
			var myImage = myLink.parent;
			if (myImage.effectivePpi[0] < myDialogResult.minimumDpi || myImage.effectivePpi[1] < myDialogResult.minimumDpi) {
				myLowResImages.push(myImage);
			}
		}
	}
	if (myLowResImages.length > 0) {
		if (myLowResImages.length == 1) {
			var myImg = localize({en: ' image', ru: ' картинка'});
			var myNumber = "";
		}
		else {
			var myImg =  localize({en: ' images', ru: ' картинок'});
		}
		var myMessage = localize({en: 'The document contains ', ru: 'Этот документ содержит '}) + myLowResImages.length + myImg + localize({en: ', effective resolution of which is below ', ru: ' эффективное разрешение. которых '}) + myDialogResult.minimumDpi + " Dpi:\r";
		for (p = 0; p < myLowResImages.length; p++) {
			var myLowResImage = myLowResImages[p];
			if (myLowResImages.length == 1) {
				var myNumber = "";
			}
			else {
				var myNumber = (p + 1) + ". ";
			}
			myMessage += myNumber + myLowResImage.itemLink.name + " -- " + myLowResImage.effectivePpi[0] + "x" + myLowResImage.effectivePpi[1] + " Dpi\r";
		}
		var myConfirmRes = confirm(myMessage + localize({en: '\rDo you want to interrupt the script and correct the problem?', ru: 'Хотите остановить скрипт и исправить?'}), false, localize({en: 'Low Resotution Images', ru: 'Картинки с низким разрешением'}));
		if (myConfirmRes) exit();
	}
}
//--------------------------------------------------------------------------------------------------------------
function GetAllLinks() {
	if (myDialogResult.onlySelected && myDialogResult.onlySelEnabled) { // Process only selected images
		var myGetAllLinks = [];
		if (app.selection.length == 1 && app.selection[0].constructor.name == "Image" ) {
			myGetAllLinks.push(app.selection[0].itemLink);
		}
		else if (app.selection.length == 1 && app.selection[0].allGraphics.length == 1) {
			myGetAllLinks.push(app.selection[0].allGraphics[0].itemLink);
		}
		else if (app.selection.length >= 1 && app.selection[0].allGraphics.length > 0) { // Process all graphics in all selections
			for (var l =  0; l < app.selection.length; l++) {
				var myAllGraphics = app.selection[l].allGraphics;
				if (myAllGraphics.length > 0) {
					for (var m =  0; m < myAllGraphics.length; m++) {
						try {
							var myCurrentLink = myAllGraphics[m].itemLink;
							myGetAllLinks.push(myCurrentLink);
						}
						catch(e) {
							$.writeln("Error -- " + e.message);
						}
					}
				}
			}
		}
	}
	else {
		var myGetAllLinks = myDoc.links;
	}
	return myGetAllLinks;
}
//--------------------------------------------------------------------------------------------------------------
function IsObjInArray(myObj, myArray) {
	for (x in myArray) {
		if (myObj.filePath == myArray[x].filePath) {
			return true;
		}
	}
	return false;
}